/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdlib.h>


typedef enum {
  /**
   * Resets all the attributes.
   */
  CROSSTERM_ATTRIBUTE_RESET,
  /**
   * Increases the text intensity.
   */
  CROSSTERM_ATTRIBUTE_BOLD,
  /**
   * Decreases the text intensity.
   */
  CROSSTERM_ATTRIBUTE_DIM,
  /**
   * Emphasises the text.
   */
  CROSSTERM_ATTRIBUTE_ITALIC,
  /**
   * Underlines the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERLINED,
  /**
   * Double underlines the text.
   */
  CROSSTERM_ATTRIBUTE_DOUBLE_UNDERLINED,
  /**
   * Undercurls the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERCURLED,
  /**
   * Underdots the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERDOTTED,
  /**
   * Underdashes the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERDASHED,
  /**
   * Makes the text blinking (< 150 per minute).
   */
  CROSSTERM_ATTRIBUTE_SLOW_BLINK,
  /**
   * Makes the text blinking (>= 150 per minute).
   */
  CROSSTERM_ATTRIBUTE_RAPID_BLINK,
  /**
   * Swaps foreground and background colors.
   */
  CROSSTERM_ATTRIBUTE_REVERSE,
  /**
   * Hides the text (also known as Conceal).
   */
  CROSSTERM_ATTRIBUTE_HIDDEN,
  /**
   * Crosses the text.
   */
  CROSSTERM_ATTRIBUTE_CROSSED_OUT,
  /**
   * Sets the [Fraktur](https://en.wikipedia.org/wiki/Fraktur) typeface.
   *
   * Mostly used for [mathematical alphanumeric symbols](https://en.wikipedia.org/wiki/Mathematical_Alphanumeric_Symbols).
   */
  CROSSTERM_ATTRIBUTE_FRAKTUR,
  /**
   * Turns off the `Bold` attribute. - Inconsistent - Prefer to use NormalIntensity
   */
  CROSSTERM_ATTRIBUTE_NO_BOLD,
  /**
   * Switches the text back to normal intensity (no bold, italic).
   */
  CROSSTERM_ATTRIBUTE_NORMAL_INTENSITY,
  /**
   * Turns off the `Italic` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_ITALIC,
  /**
   * Turns off the `Underlined` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_UNDERLINE,
  /**
   * Turns off the text blinking (`SlowBlink` or `RapidBlink`).
   */
  CROSSTERM_ATTRIBUTE_NO_BLINK,
  /**
   * Turns off the `Reverse` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_REVERSE,
  /**
   * Turns off the `Hidden` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_HIDDEN,
  /**
   * Turns off the `CrossedOut` attribute.
   */
  CROSSTERM_ATTRIBUTE_NOT_CROSSED_OUT,
  /**
   * Makes the text framed.
   */
  CROSSTERM_ATTRIBUTE_FRAMED,
  /**
   * Makes the text encircled.
   */
  CROSSTERM_ATTRIBUTE_ENCIRCLED,
  /**
   * Draws a line at the top of the text.
   */
  CROSSTERM_ATTRIBUTE_OVER_LINED,
  /**
   * Turns off the `Frame` and `Encircled` attributes.
   */
  CROSSTERM_ATTRIBUTE_NOT_FRAMED_OR_ENCIRCLED,
  /**
   * Turns off the `OverLined` attribute.
   */
  CROSSTERM_ATTRIBUTE_NOT_OVER_LINED,
} crossterm_Attribute;

/**
 * Different ways to clear the terminal buffer.
 */
typedef enum {
  /**
   * All cells.
   */
  CROSSTERM_CLEAR_TYPE_ALL,
  /**
   * All plus history
   */
  CROSSTERM_CLEAR_TYPE_PURGE,
  /**
   * All cells from the cursor position downwards.
   */
  CROSSTERM_CLEAR_TYPE_FROM_CURSOR_DOWN,
  /**
   * All cells from the cursor position upwards.
   */
  CROSSTERM_CLEAR_TYPE_FROM_CURSOR_UP,
  /**
   * All cells at the cursor row.
   */
  CROSSTERM_CLEAR_TYPE_CURRENT_LINE,
  /**
   * All cells from the cursor position until the new line.
   */
  CROSSTERM_CLEAR_TYPE_UNTIL_NEW_LINE,
} crossterm_ClearType;

/**
 * Style of the cursor.
 * It uses two types of escape codes, one to control blinking, and the other the shape.
 */
typedef enum {
  /**
   * Default cursor shape configured by the user.
   */
  CROSSTERM_CURSOR_STYLE_DEFAULT_USER_SHAPE,
  /**
   * A blinking block cursor shape (■).
   */
  CROSSTERM_CURSOR_STYLE_BLINKING_BLOCK,
  /**
   * A non blinking block cursor shape (inverse of `BlinkingBlock`).
   */
  CROSSTERM_CURSOR_STYLE_STEADY_BLOCK,
  /**
   * A blinking underscore cursor shape(_).
   */
  CROSSTERM_CURSOR_STYLE_BLINKING_UNDER_SCORE,
  /**
   * A non blinking underscore cursor shape (inverse of `BlinkingUnderScore`).
   */
  CROSSTERM_CURSOR_STYLE_STEADY_UNDER_SCORE,
  /**
   * A blinking cursor bar shape (|)
   */
  CROSSTERM_CURSOR_STYLE_BLINKING_BAR,
  /**
   * A steady cursor bar shape (inverse of `BlinkingBar`).
   */
  CROSSTERM_CURSOR_STYLE_STEADY_BAR,
} crossterm_CursorStyle;

/**
 * Represents a keyboard event kind.
 */
typedef enum {
  CROSSTERM_KEY_EVENT_KIND_PRESS,
  CROSSTERM_KEY_EVENT_KIND_REPEAT,
  CROSSTERM_KEY_EVENT_KIND_RELEASE,
} crossterm_KeyEventKind;

/**
 * Represents a media key (as part of [`KeyCode::Media`]).
 */
typedef enum {
  /**
   * Play media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_PLAY,
  /**
   * Pause media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_PAUSE,
  /**
   * Play/Pause media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_PLAY_PAUSE,
  /**
   * Reverse media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_REVERSE,
  /**
   * Stop media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_STOP,
  /**
   * Fast-forward media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_FAST_FORWARD,
  /**
   * Rewind media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_REWIND,
  /**
   * Next-track media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_TRACK_NEXT,
  /**
   * Previous-track media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_TRACK_PREVIOUS,
  /**
   * Record media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_RECORD,
  /**
   * Lower-volume media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_LOWER_VOLUME,
  /**
   * Raise-volume media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_RAISE_VOLUME,
  /**
   * Mute media key.
   */
  CROSSTERM_MEDIA_KEY_CODE_MUTE_VOLUME,
} crossterm_MediaKeyCode;

/**
 * Represents a modifier key (as part of [`KeyCode::Modifier`]).
 */
typedef enum {
  /**
   * Left Shift key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_LEFT_SHIFT,
  /**
   * Left Control key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_LEFT_CONTROL,
  /**
   * Left Alt key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_LEFT_ALT,
  /**
   * Left Super key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_LEFT_SUPER,
  /**
   * Left Hyper key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_LEFT_HYPER,
  /**
   * Left Meta key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_LEFT_META,
  /**
   * Right Shift key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_RIGHT_SHIFT,
  /**
   * Right Control key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_RIGHT_CONTROL,
  /**
   * Right Alt key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_RIGHT_ALT,
  /**
   * Right Super key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_RIGHT_SUPER,
  /**
   * Right Hyper key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_RIGHT_HYPER,
  /**
   * Right Meta key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_RIGHT_META,
  /**
   * Iso Level3 Shift key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_ISO_LEVEL3_SHIFT,
  /**
   * Iso Level5 Shift key.
   */
  CROSSTERM_MODIFIER_KEY_CODE_ISO_LEVEL5_SHIFT,
} crossterm_ModifierKeyCode;

/**
 * Represents a mouse button.
 */
typedef enum {
  /**
   * Left mouse button.
   */
  CROSSTERM_MOUSE_BUTTON_LEFT,
  /**
   * Right mouse button.
   */
  CROSSTERM_MOUSE_BUTTON_RIGHT,
  /**
   * Middle mouse button.
   */
  CROSSTERM_MOUSE_BUTTON_MIDDLE,
} crossterm_MouseButton;

typedef enum {
  /**
   * Resets the terminal color.
   */
  CROSSTERM_COLOR_RESET,
  /**
   * Black color.
   */
  CROSSTERM_COLOR_BLACK,
  /**
   * Dark grey color.
   */
  CROSSTERM_COLOR_DARK_GREY,
  /**
   * Light red color.
   */
  CROSSTERM_COLOR_RED,
  /**
   * Dark red color.
   */
  CROSSTERM_COLOR_DARK_RED,
  /**
   * Light green color.
   */
  CROSSTERM_COLOR_GREEN,
  /**
   * Dark green color.
   */
  CROSSTERM_COLOR_DARK_GREEN,
  /**
   * Light yellow color.
   */
  CROSSTERM_COLOR_YELLOW,
  /**
   * Dark yellow color.
   */
  CROSSTERM_COLOR_DARK_YELLOW,
  /**
   * Light blue color.
   */
  CROSSTERM_COLOR_BLUE,
  /**
   * Dark blue color.
   */
  CROSSTERM_COLOR_DARK_BLUE,
  /**
   * Light magenta color.
   */
  CROSSTERM_COLOR_MAGENTA,
  /**
   * Dark magenta color.
   */
  CROSSTERM_COLOR_DARK_MAGENTA,
  /**
   * Light cyan color.
   */
  CROSSTERM_COLOR_CYAN,
  /**
   * Dark cyan color.
   */
  CROSSTERM_COLOR_DARK_CYAN,
  /**
   * White color.
   */
  CROSSTERM_COLOR_WHITE,
  /**
   * Grey color.
   */
  CROSSTERM_COLOR_GREY,
  /**
   * An RGB color. See [RGB color model](https://en.wikipedia.org/wiki/RGB_color_model) for more info.
   *
   * Most UNIX terminals and Windows 10 supported only.
   */
  CROSSTERM_COLOR_RGB,
  /**
   * An ANSI color. See [256 colors - cheat sheet](https://jonasjacek.github.io/colors/) for more info.
   *
   * Most UNIX terminals and Windows 10 supported only.
   */
  CROSSTERM_COLOR_ANSI_VALUE,
} crossterm_Color_Tag;

typedef struct {
  uint8_t r;
  uint8_t g;
  uint8_t b;
} crossterm_Rgb_Body;

typedef struct {
  crossterm_Color_Tag tag;
  union {
    crossterm_Rgb_Body RGB;
    struct {
      uint8_t ansi_value;
    };
  };
} crossterm_Color;

/**
 * Represents a key.
 */
typedef enum {
  /**
   * Backspace key.
   */
  CROSSTERM_KEY_CODE_BACKSPACE,
  /**
   * Enter key.
   */
  CROSSTERM_KEY_CODE_ENTER,
  /**
   * Left arrow key.
   */
  CROSSTERM_KEY_CODE_LEFT,
  /**
   * Right arrow key.
   */
  CROSSTERM_KEY_CODE_RIGHT,
  /**
   * Up arrow key.
   */
  CROSSTERM_KEY_CODE_UP,
  /**
   * Down arrow key.
   */
  CROSSTERM_KEY_CODE_DOWN,
  /**
   * Home key.
   */
  CROSSTERM_KEY_CODE_HOME,
  /**
   * End key.
   */
  CROSSTERM_KEY_CODE_END,
  /**
   * Page up key.
   */
  CROSSTERM_KEY_CODE_PAGE_UP,
  /**
   * Page down key.
   */
  CROSSTERM_KEY_CODE_PAGE_DOWN,
  /**
   * Tab key.
   */
  CROSSTERM_KEY_CODE_TAB,
  /**
   * Shift + Tab key.
   */
  CROSSTERM_KEY_CODE_BACK_TAB,
  /**
   * Delete key.
   */
  CROSSTERM_KEY_CODE_DELETE,
  /**
   * Insert key.
   */
  CROSSTERM_KEY_CODE_INSERT,
  /**
   * F key.
   *
   * `KeyCode::F(1)` represents F1 key, etc.
   */
  CROSSTERM_KEY_CODE_F,
  /**
   * A character.
   *
   * `KeyCode::Char('c')` represents `c` character, etc.
   */
  CROSSTERM_KEY_CODE_CHAR,
  /**
   * Null.
   */
  CROSSTERM_KEY_CODE_NULL,
  /**
   * Escape key.
   */
  CROSSTERM_KEY_CODE_ESC,
  /**
   * Caps Lock key.
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_CAPS_LOCK,
  /**
   * Scroll Lock key.
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_SCROLL_LOCK,
  /**
   * Num Lock key.
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_NUM_LOCK,
  /**
   * Print Screen key.
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_PRINT_SCREEN,
  /**
   * Pause key.
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_PAUSE,
  /**
   * Menu key.
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_MENU,
  /**
   * The "Begin" key (often mapped to the 5 key when Num Lock is turned on).
   *
   * **Note:** this key can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_KEYPAD_BEGIN,
  /**
   * A media key.
   *
   * **Note:** these keys can only be read if
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_MEDIA,
  /**
   * A modifier key.
   *
   * **Note:** these keys can only be read if **both**
   * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] and
   * [`KeyboardEnhancementFlags::REPORT_ALL_KEYS_AS_ESCAPE_CODES`] have been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  CROSSTERM_KEY_CODE_MODIFIER,
} crossterm_KeyCode_Tag;

typedef struct {
  crossterm_KeyCode_Tag tag;
  union {
    struct {
      uint8_t f;
    };
    struct {
      uint32_t char_;
    };
    struct {
      crossterm_MediaKeyCode media;
    };
    struct {
      crossterm_ModifierKeyCode modifier;
    };
  };
} crossterm_KeyCode;

/**
 * Represents key modifiers (shift, control, alt, etc.).
 *
 * **Note:** `SUPER`, `HYPER`, and `META` can only be read if
 * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
 * [`PushKeyboardEnhancementFlags`].
 */
typedef struct {
  uint8_t bits;
} crossterm_KeyModifiers;
#define crossterm_KeyModifiers_SHIFT (crossterm_KeyModifiers){ .bits = (uint8_t)1 }
#define crossterm_KeyModifiers_CONTROL (crossterm_KeyModifiers){ .bits = (uint8_t)2 }
#define crossterm_KeyModifiers_ALT (crossterm_KeyModifiers){ .bits = (uint8_t)4 }
#define crossterm_KeyModifiers_SUPER (crossterm_KeyModifiers){ .bits = (uint8_t)8 }
#define crossterm_KeyModifiers_HYPER (crossterm_KeyModifiers){ .bits = (uint8_t)16 }
#define crossterm_KeyModifiers_META (crossterm_KeyModifiers){ .bits = (uint8_t)32 }
#define crossterm_KeyModifiers_NONE (crossterm_KeyModifiers){ .bits = (uint8_t)0 }

/**
 * Represents extra state about the key event.
 *
 * **Note:** This state can only be read if
 * [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
 * [`crossterm_event_push_keyboard_enhancement_flags`].
 */
typedef struct {
  uint8_t bits;
} crossterm_KeyEventState;
/**
 * The key event origins from the keypad.
 */
#define crossterm_KeyEventState_KEYPAD (crossterm_KeyEventState){ .bits = (uint8_t)1 }
/**
 * Caps Lock was enabled for this key event.
 *
 * **Note:** this is set for the initial press of Caps Lock itself.
 */
#define crossterm_KeyEventState_CAPS_LOCK (crossterm_KeyEventState){ .bits = (uint8_t)8 }
/**
 * Num Lock was enabled for this key event.
 *
 * **Note:** this is set for the initial press of Num Lock itself.
 */
#define crossterm_KeyEventState_NUM_LOCK (crossterm_KeyEventState){ .bits = (uint8_t)8 }
#define crossterm_KeyEventState_NONE (crossterm_KeyEventState){ .bits = (uint8_t)0 }

/**
 * Represents a key event.
 */
typedef struct {
  /**
   * The key itself.
   */
  crossterm_KeyCode code;
  /**
   * Additional key modifiers.
   */
  crossterm_KeyModifiers modifiers;
  /**
   * Kind of event.
   *
   * Only set if:
   * - Unix: [`KeyboardEnhancementFlags::REPORT_EVENT_TYPES`] has been enabled with [`crossterm_event_push_keyboard_enhancement_flags`].
   * - Windows: always
   */
  crossterm_KeyEventKind kind;
  /**
   * Keyboard state.
   *
   * Only set if [`KeyboardEnhancementFlags::DISAMBIGUATE_ESCAPE_CODES`] has been enabled with
   * [`PushKeyboardEnhancementFlags`].
   */
  crossterm_KeyEventState state;
} crossterm_KeyEvent;

/**
 * A mouse event kind.
 *
 * # Platform-specific Notes
 *
 * ## Mouse Buttons
 *
 * Some platforms/terminals do not report mouse button for the
 * `MouseEventKind::Up` and `MouseEventKind::Drag` events. `MouseButton::Left`
 * is returned if we don't know which button was used.
 */
typedef enum {
  /**
   * Pressed mouse button. Contains the button that was pressed.
   */
  CROSSTERM_MOUSE_EVENT_KIND_DOWN,
  /**
   * Released mouse button. Contains the button that was released.
   */
  CROSSTERM_MOUSE_EVENT_KIND_UP,
  /**
   * Moved the mouse cursor while pressing the contained mouse button.
   */
  CROSSTERM_MOUSE_EVENT_KIND_DRAG,
  /**
   * Moved the mouse cursor while not pressing a mouse button.
   */
  CROSSTERM_MOUSE_EVENT_KIND_MOVED,
  /**
   * Scrolled mouse wheel downwards (towards the user).
   */
  CROSSTERM_MOUSE_EVENT_KIND_SCROLL_DOWN,
  /**
   * Scrolled mouse wheel upwards (away from the user).
   */
  CROSSTERM_MOUSE_EVENT_KIND_SCROLL_UP,
} crossterm_MouseEventKind_Tag;

typedef struct {
  crossterm_MouseEventKind_Tag tag;
  union {
    struct {
      crossterm_MouseButton down;
    };
    struct {
      crossterm_MouseButton up;
    };
    struct {
      crossterm_MouseButton drag;
    };
  };
} crossterm_MouseEventKind;

/**
 * Represents a mouse event.
 *
 * # Platform-specific Notes
 *
 * ## Mouse Buttons
 *
 * Some platforms/terminals do not report mouse button for the
 * `MouseEventKind::Up` and `MouseEventKind::Drag` events. `MouseButton::Left`
 * is returned if we don't know which button was used.
 *
 * ## Key Modifiers
 *
 * Some platforms/terminals does not report all key modifiers
 * combinations for all mouse event types. For example - macOS reports
 * `Ctrl` + left mouse button click as a right mouse button click.
 */
typedef struct {
  /**
   * The kind of mouse event that was caused.
   */
  crossterm_MouseEventKind kind;
  /**
   * The col that the event occurred on.
   */
  uint16_t col;
  /**
   * The row that the event occurred on.
   */
  uint16_t row;
  /**
   * The key modifiers active when the event occurred.
   */
  crossterm_KeyModifiers modifiers;
} crossterm_MouseEvent;

/**
 * Represents an event.
 */
typedef enum {
  /**
   * The terminal gained focus
   */
  CROSSTERM_EVENT_FOCUS_GAINED,
  /**
   * The terminal lost focus
   */
  CROSSTERM_EVENT_FOCUS_LOST,
  /**
   * A single key event with additional pressed modifiers.
   */
  CROSSTERM_EVENT_KEY,
  /**
   * A single mouse event with additional pressed modifiers.
   */
  CROSSTERM_EVENT_MOUSE,
  /**
   * A string that was pasted into the terminal. Only emitted if bracketed paste has been
   * enabled.
   */
  CROSSTERM_EVENT_PASTE,
  /**
   * An resize event with new dimensions after resize (cols, rows).
   * **Note** that resize events can occur in batches.
   */
  CROSSTERM_EVENT_RESIZE,
} crossterm_Event_Tag;

typedef struct {
  uint16_t _0;
  uint16_t _1;
} crossterm_Resize_Body;

typedef struct {
  crossterm_Event_Tag tag;
  union {
    struct {
      crossterm_KeyEvent key;
    };
    struct {
      crossterm_MouseEvent mouse;
    };
    struct {
      const char *paste;
    };
    crossterm_Resize_Body RESIZE;
  };
} crossterm_Event;

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

void crossterm_clear_last_error(void);

/**
 * Returns colors as a UTF-8 JSON string.
 *
 * Null character is stored in the last location of buffer.
 * Caller is responsible for memory associated with string buffer.
 * Use [`crossterm_free_c_char`] to free data.
 */
const char *crossterm_colors(void);

/**
 * Disables blinking of the terminal cursor.
 */
int crossterm_cursor_disable_blinking(void);

/**
 * Enables blinking of the terminal cursor.
 */
int crossterm_cursor_enable_blinking(void);

/**
 * Hides the terminal cursor.
 */
int crossterm_cursor_hide(void);

/**
 * Moves the terminal cursor a given number of rows down.
 */
int crossterm_cursor_move_down(uint16_t rows);

/**
 * Moves the terminal cursor a given number of cols to the left.
 */
int crossterm_cursor_move_left(uint16_t cols);

/**
 * Moves the terminal cursor a given number of cols to the right.
 */
int crossterm_cursor_move_right(uint16_t cols);

/**
 * Moves the terminal cursor to the given position (col, row).
 *
 * # Notes
 * * Top left cell is represented as `0,0`.
 */
int crossterm_cursor_move_to(uint16_t col, uint16_t row);

/**
 * Moves the terminal cursor to the given col on the current row.
 */
int crossterm_cursor_move_to_column(uint16_t col);

/**
 * Moves the terminal cursor down the given number of lines and moves it to the first col.
 *
 * # Notes
 * * This command is 1 based, meaning `crossterm_cursor_move_to_next_line(1)` moves to the next line.
 * * Most terminals default 0 argument to 1.
 */
int crossterm_cursor_move_to_next_line(uint16_t n);

/**
 * Moves the terminal cursor up the given number of lines and moves it to the first col.
 */
int crossterm_cursor_move_to_previous_line(uint16_t n);

/**
 * Moves the terminal cursor to the given row on the current col.
 */
int crossterm_cursor_move_to_row(uint16_t row);

/**
 * Moves the terminal cursor a given number of rows up.
 */
int crossterm_cursor_move_up(uint16_t rows);

/**
 * Get cursor position (col, row)
 *
 * # Notes
 * * Top left cell is represented as `0,0`.
 */
int crossterm_cursor_position(uint16_t *col, uint16_t *row);

/**
 * Set cursor position (col, row)
 *
 * # Notes
 * * Top left cell is represented as `0,0`.
 */
int crossterm_cursor_position_set(uint16_t col, uint16_t row);

/**
 * Restores the saved terminal cursor position.
 */
int crossterm_cursor_restore_position(void);

/**
 * Saves the current terminal cursor position.
 */
int crossterm_cursor_save_position(void);

/**
 * Shows the terminal cursor.
 */
int crossterm_cursor_show(void);

/**
 * Sets the style of the cursor.
 */
int crossterm_cursor_style(crossterm_CursorStyle cursor_style);

/**
 * Sets the style of the cursor to a blinking bar.
 */
int crossterm_cursor_style_blinking_bar(void);

/**
 * Sets the style of the cursor to a blinking block.
 */
int crossterm_cursor_style_blinking_block(void);

/**
 * Sets the style of the cursor to a blinking underscore.
 */
int crossterm_cursor_style_blinking_underscore(void);

/**
 * Sets the style of the cursor to default user shape.
 */
int crossterm_cursor_style_default_user_shape(void);

/**
 * Sets the style of the cursor to a steady bar.
 */
int crossterm_cursor_style_steady_bar(void);

/**
 * Sets the style of the cursor to a steady block.
 */
int crossterm_cursor_style_steady_block(void);

/**
 * Sets the style of the cursor to a steady underscore.
 */
int crossterm_cursor_style_steady_underscore(void);

/**
 * Disables bracketed paste mode.
 */
int crossterm_event_disable_bracketed_paste(void);

/**
 * Disable focus event emission.
 */
int crossterm_event_disable_focus_change(void);

/**
 * Disable mouse event capturing.
 */
int crossterm_event_disable_mouse_capture(void);

/**
 * Enables [bracketed paste mode](https://en.wikipedia.org/wiki/Bracketed-paste).
 *
 * It should be paired with [`crossterm_event_disable_bracketed_paste`] at the end of execution.
 *
 * This is not supported in older Windows terminals without
 * [virtual terminal sequences](https://docs.microsoft.com/en-us/windows/console/console-virtual-terminal-sequences).
 */
int crossterm_event_enable_bracketed_paste(void);

/**
 * Enable focus event emission.
 *
 * It should be paired with [`crossterm_event_disable_focus_change`] at the end of execution.
 *
 * Focus events can be captured with [`crossterm_event_read`].
 */
int crossterm_event_enable_focus_change(void);

/**
 * Enable mouse event capturing.
 */
int crossterm_event_enable_mouse_capture(void);

/**
 * Checks if there is an [`Event`] available.
 *
 * Returns `1` if an [`Event`] is available, it returns `0` if no [`Event`] is available, returns -1 if error has occurred.
 *
 * When it returns `1`, that guarantees that subsequent call to the [`crossterm_event_read`] function
 * won't block.
 *
 * # Arguments
 *
 * * `timeout_secs` - maximum waiting time for event availability
 * * `timeout_nanos` - maximum waiting time for event availability
 */
int crossterm_event_poll(uint64_t secs,
                         uint32_t nanos);

/**
 * Disables extra kinds of keyboard events.
 */
int crossterm_event_pop_keyboard_enhancement_flags(void);

/**
 * Enables the [kitty keyboard protocol](https://sw.kovidgoyal.net/kitty/keyboard-protocol/),
 * which adds extra information to keyboard events and removes ambiguity for modifier keys.
 * It should be paired with [`crossterm_pop_keyboard_enhancement_flags`] at the end of execution.
 */
int crossterm_event_push_keyboard_enhancement_flags(uint8_t flags);

/**
 * Reads a single [`Event`] as a UTF-8 JSON string.
 * If error occurs during read, error will be returned as a UTF-8 JSON string.
 *
 * This function blocks until an [`Event`] is available.
 * Combine it with the [`crossterm_event_poll`] function to get non-blocking reads.
 *
 * Caller is responsible for memory associated with string buffer.
 * Use [`crossterm_free_c_char`] to free data.
 */
const char *crossterm_event_read(void);

/**
 * Flush the stdout stream, ensuring that all intermediately buffered contents reach their destination.
 *
 * It is considered an error if not all bytes could be written due to I/O errors or EOF being reached.
 */
int crossterm_flush(void);

/**
 * Frees data behind pointer to UTF-8 string allocated by this crate
 *
 * Null character is stored in the last location of buffer.
 */
int crossterm_free_c_char(char *s);

/**
 * Check whether error has been set.
 */
bool crossterm_has_error(void);

/**
 * Calculate the number of bytes in the last error's error message including a
 * trailing `null` character. If there are no recent error, then this returns
 * `0`.
 */
int crossterm_last_error_length(void);

/**
 * Return most recent error message into a UTF-8 string buffer.
 *
 * Null character is stored in the last location of buffer.
 * Caller is responsible for memory associated with string buffer.
 * Use [`crossterm_free_c_char`] to free data.
 */
const char *crossterm_last_error_message(void);

/**
 * Sleeps for n seconds where n is the argument to this function
 */
void crossterm_sleep(double seconds);

/**
 * Sets an attribute.
 *
 * See [`Attribute`] for more info.
 */
int crossterm_style_attribute(crossterm_Attribute attr);

/**
 * Sets the `Bold` attribute.
 */
int crossterm_style_attribute_bold(void);

/**
 * Sets the `CrossedOut` attribute.
 */
int crossterm_style_attribute_crossed_out(void);

/**
 * Sets the `Dim` attribute.
 */
int crossterm_style_attribute_dim(void);

/**
 * Sets the `DoubleUnderlined` attribute.
 */
int crossterm_style_attribute_double_underlined(void);

/**
 * Sets the `Fraktur` attribute.
 */
int crossterm_style_attribute_fraktur(void);

/**
 * Sets the `Hidden` attribute.
 */
int crossterm_style_attribute_hidden(void);

/**
 * Sets the `Italic` attribute.
 */
int crossterm_style_attribute_italic(void);

/**
 * Sets the `NoBlink` attribute.
 */
int crossterm_style_attribute_no_blink(void);

/**
 * Sets the `NoBold` attribute.
 */
int crossterm_style_attribute_no_bold(void);

/**
 * Sets the `NoHidden` attribute.
 */
int crossterm_style_attribute_no_hidden(void);

/**
 * Sets the `NoItalic` attribute.
 */
int crossterm_style_attribute_no_italic(void);

/**
 * Sets the `NoReverse` attribute.
 */
int crossterm_style_attribute_no_reverse(void);

/**
 * Sets the `NoUnderline` attribute.
 */
int crossterm_style_attribute_no_underline(void);

/**
 * Sets the `NormalIntensity` attribute.
 */
int crossterm_style_attribute_normal_intensity(void);

/**
 * Sets the `NotCrossedOut` attribute.
 */
int crossterm_style_attribute_not_crossed_out(void);

/**
 * Sets the `RapidBlink` attribute.
 */
int crossterm_style_attribute_rapid_blink(void);

/**
 * Sets the `Reset` attribute.
 */
int crossterm_style_attribute_reset(void);

/**
 * Sets the `Reverse` attribute.
 */
int crossterm_style_attribute_reverse(void);

/**
 * Sets the `SlowBlink` attribute.
 */
int crossterm_style_attribute_slow_blink(void);

/**
 * Sets the `Undercurled` attribute.
 */
int crossterm_style_attribute_undercurled(void);

/**
 * Sets the `Underdashed` attribute.
 */
int crossterm_style_attribute_underdashed(void);

/**
 * Sets the `Underdotted` attribute.
 */
int crossterm_style_attribute_underdotted(void);

/**
 * Sets the `Underlined` attribute.
 */
int crossterm_style_attribute_underlined(void);

/**
 * Sets the the background color.
 *
 * See [`Color`] for more info.
 */
int crossterm_style_background_color(crossterm_Color color);

/**
 * Sets the the background color to an ANSI value.
 */
int crossterm_style_background_color_ansi(uint8_t value);

/**
 * Sets the the background color to Black.
 */
int crossterm_style_background_color_black(void);

/**
 * Sets the the background color to Blue.
 */
int crossterm_style_background_color_blue(void);

/**
 * Sets the the background color to Cyan.
 */
int crossterm_style_background_color_cyan(void);

/**
 * Sets the the background color to DarkBlue.
 */
int crossterm_style_background_color_dark_blue(void);

/**
 * Sets the the background color to DarkCyan.
 */
int crossterm_style_background_color_dark_cyan(void);

/**
 * Sets the the background color to DarkGreen.
 */
int crossterm_style_background_color_dark_green(void);

/**
 * Sets the the background color to DarkGrey.
 */
int crossterm_style_background_color_dark_grey(void);

/**
 * Sets the the background color to DarkMagenta.
 */
int crossterm_style_background_color_dark_magenta(void);

/**
 * Sets the the background color to DarkRed.
 */
int crossterm_style_background_color_dark_red(void);

/**
 * Sets the the background color to DarkYellow.
 */
int crossterm_style_background_color_dark_yellow(void);

/**
 * Sets the the background color to Green.
 */
int crossterm_style_background_color_green(void);

/**
 * Sets the the background color to Grey.
 */
int crossterm_style_background_color_grey(void);

/**
 * Sets the the background color to Magenta.
 */
int crossterm_style_background_color_magenta(void);

/**
 * Sets the the background color to Red.
 */
int crossterm_style_background_color_red(void);

/**
 * Sets the the background color to Reset.
 */
int crossterm_style_background_color_reset(void);

/**
 * Sets the the background color in RGB.
 */
int crossterm_style_background_color_rgb(uint8_t r, uint8_t g, uint8_t b);

/**
 * Sets the the background color to White.
 */
int crossterm_style_background_color_white(void);

/**
 * Sets the the background color to Yellow.
 */
int crossterm_style_background_color_yellow(void);

/**
 * Sets the the foreground color.
 *
 * See [`Color`] for more info.
 */
int crossterm_style_foreground_color(crossterm_Color color);

/**
 * Sets the the foreground color to an ANSI value.
 */
int crossterm_style_foreground_color_ansi(uint8_t value);

/**
 * Sets the the foreground color to Black.
 */
int crossterm_style_foreground_color_black(void);

/**
 * Sets the the foreground color to Blue.
 */
int crossterm_style_foreground_color_blue(void);

/**
 * Sets the the foreground color to Cyan.
 */
int crossterm_style_foreground_color_cyan(void);

/**
 * Sets the the foreground color to DarkBlue.
 */
int crossterm_style_foreground_color_dark_blue(void);

/**
 * Sets the the foreground color to DarkCyan.
 */
int crossterm_style_foreground_color_dark_cyan(void);

/**
 * Sets the the foreground color to DarkGreen.
 */
int crossterm_style_foreground_color_dark_green(void);

/**
 * Sets the the foreground color to DarkGrey.
 */
int crossterm_style_foreground_color_dark_grey(void);

/**
 * Sets the the foreground color to DarkMagenta.
 */
int crossterm_style_foreground_color_dark_magenta(void);

/**
 * Sets the the foreground color to DarkRed.
 */
int crossterm_style_foreground_color_dark_red(void);

/**
 * Sets the the foreground color to DarkYellow.
 */
int crossterm_style_foreground_color_dark_yellow(void);

/**
 * Sets the the foreground color to Green.
 */
int crossterm_style_foreground_color_green(void);

/**
 * Sets the the foreground color to Grey.
 */
int crossterm_style_foreground_color_grey(void);

/**
 * Sets the the foreground color to Magenta.
 */
int crossterm_style_foreground_color_magenta(void);

/**
 * Sets the the foreground color to Red.
 */
int crossterm_style_foreground_color_red(void);

/**
 * Sets the the foreground color to Reset.
 */
int crossterm_style_foreground_color_reset(void);

/**
 * Sets the the foreground color in RGB.
 */
int crossterm_style_foreground_color_rgb(uint8_t r, uint8_t g, uint8_t b);

/**
 * Sets the the foreground color to White.
 */
int crossterm_style_foreground_color_white(void);

/**
 * Sets the the foreground color to Yellow.
 */
int crossterm_style_foreground_color_yellow(void);

/**
 * Print string to stdout
 *
 * # Safety
 *
 * This function takes a raw pointer as argument. As such, the caller must ensure that:
 * - The `title` pointer points to a valid null-terminated string.
 * - This function borrows a slice to a valid null-terminated string and the memory referenced by `title` won't be deallocated or modified for the duration of the function call..
 * - The `title` pointer is correctly aligned and `title` points to an initialized memory.
 *
 * If these conditions are not met, the behavior is undefined.
 */
int crossterm_style_print(const char *s);

/**
 * Print char to stdout
 */
int crossterm_style_print_char(uint32_t c);

/**
 * Print string to stdout
 *
 * # Safety
 *
 * This function takes a raw pointer as argument. As such, the caller must ensure that:
 * - The `title` pointer points to a valid null-terminated string.
 * - This function borrows a slice to a valid null-terminated string and the memory referenced by `title` won't be deallocated or modified for the duration of the function call..
 * - The `title` pointer is correctly aligned and `title` points to an initialized memory.
 *
 * If these conditions are not met, the behavior is undefined.
 */
int crossterm_style_print_string(const char *s);

/**
 * Resets the colors back to default.
 */
int crossterm_style_reset_color(void);

/**
 * Sets the the underline color.
 *
 * See [`Color`] for more info.
 */
int crossterm_style_underline_color(crossterm_Color color);

/**
 * Sets the the underline color to an ANSI value.
 */
int crossterm_style_underline_color_ansi(uint8_t value);

/**
 * Sets the the underline color to Black.
 */
int crossterm_style_underline_color_black(void);

/**
 * Sets the the underline color to Blue.
 */
int crossterm_style_underline_color_blue(void);

/**
 * Sets the the underline color to Cyan.
 */
int crossterm_style_underline_color_cyan(void);

/**
 * Sets the the underline color to DarkBlue.
 */
int crossterm_style_underline_color_dark_blue(void);

/**
 * Sets the the underline color to DarkCyan.
 */
int crossterm_style_underline_color_dark_cyan(void);

/**
 * Sets the the underline color to DarkGreen.
 */
int crossterm_style_underline_color_dark_green(void);

/**
 * Sets the the underline color to DarkGrey.
 */
int crossterm_style_underline_color_dark_grey(void);

/**
 * Sets the the underline color to DarkMagenta.
 */
int crossterm_style_underline_color_dark_magenta(void);

/**
 * Sets the the underline color to DarkRed.
 */
int crossterm_style_underline_color_dark_red(void);

/**
 * Sets the the underline color to DarkYellow.
 */
int crossterm_style_underline_color_dark_yellow(void);

/**
 * Sets the the underline color to Green.
 */
int crossterm_style_underline_color_green(void);

/**
 * Sets the the underline color to Grey.
 */
int crossterm_style_underline_color_grey(void);

/**
 * Sets the the underline color to Magenta.
 */
int crossterm_style_underline_color_magenta(void);

/**
 * Sets the the underline color to Red.
 */
int crossterm_style_underline_color_red(void);

/**
 * Sets the the underline color to Reset.
 */
int crossterm_style_underline_color_reset(void);

/**
 * Sets the the underline color in RGB.
 */
int crossterm_style_underline_color_rgb(uint8_t r, uint8_t g, uint8_t b);

/**
 * Sets the the underline color to White.
 */
int crossterm_style_underline_color_white(void);

/**
 * Sets the the underline color to Yellow.
 */
int crossterm_style_underline_color_yellow(void);

/**
 * Instructs the terminal emulator to begin a synchronized frame.
 *
 * # Notes
 *
 * * Commands must be executed/queued for execution otherwise they do nothing.
 * * Use [`crossterm_terminal_end_synchronized_update`] command to leave the entered alternate screen.
 *
 * When rendering the screen of the terminal, the Emulator usually iterates through each visible grid cell and
 * renders its current state. With applications updating the screen a at higher frequency this can cause tearing.
 *
 * This mode attempts to mitigate that.
 *
 * When the synchronization mode is enabled following render calls will keep rendering the last rendered state.
 * The terminal Emulator keeps processing incoming text and sequences. When the synchronized update mode is disabled
 * again the renderer may fetch the latest screen buffer state again, effectively avoiding the tearing effect
 * by unintentionally rendering in the middle a of an application screen update.
 */
int crossterm_terminal_begin_synchronized_update(void);

/**
 * Clear screen command.
 */
int crossterm_terminal_clear(crossterm_ClearType ct);

/**
 * Disables line wrapping.
 */
int crossterm_terminal_disable_line_wrap(void);

/**
 * Disables raw mode.
 */
int crossterm_terminal_disable_raw_mode(void);

/**
 * Enables line wrapping.
 */
int crossterm_terminal_enable_line_wrap(void);

/**
 * Enables raw mode.
 */
int crossterm_terminal_enable_raw_mode(void);

/**
 * Instructs the terminal to end a synchronized frame.
 *
 * # Notes
 *
 * * Commands must be executed/queued for execution otherwise they do nothing.
 * * Use [`crossterm_terminal_begin_synchronized_update`] to enter the alternate screen.
 *
 * When rendering the screen of the terminal, the Emulator usually iterates through each visible grid cell and
 * renders its current state. With applications updating the screen a at higher frequency this can cause tearing.
 *
 * This mode attempts to mitigate that.
 *
 * When the synchronization mode is enabled following render calls will keep rendering the last rendered state.
 * The terminal Emulator keeps processing incoming text and sequences. When the synchronized update mode is disabled
 * again the renderer may fetch the latest screen buffer state again, effectively avoiding the tearing effect
 * by unintentionally rendering in the middle a of an application screen update.
 */
int crossterm_terminal_end_synchronized_update(void);

/**
 * Enters alternate screen.
 */
int crossterm_terminal_enter_alternate_screen(void);

/**
 * Leaves alternate screen.
 */
int crossterm_terminal_leave_alternate_screen(void);

/**
 * Instructs the terminal to send a bell.
 */
int crossterm_terminal_ring_bell(void);

/**
 * Scroll down command.
 */
int crossterm_terminal_scroll_down(unsigned short n);

/**
 * Scroll up command.
 */
int crossterm_terminal_scroll_up(unsigned short n);

/**
 * Get terminal size
 */
int crossterm_terminal_size(uint16_t *width, uint16_t *height);

/**
 * Sets the terminal buffer size `(cols, rows)`.
 */
int crossterm_terminal_size_set(uint16_t cols, uint16_t rows);

/**
 * Sets terminal title.
 *
 * # Safety
 *
 * This function takes a raw pointer as argument. As such, the caller must ensure that:
 * - The `title` pointer points to a valid null-terminated string.
 * - This function borrows a slice to a valid null-terminated string and the memory referenced by `title` won't be deallocated or modified for the duration of the function call..
 * - The `title` pointer is correctly aligned and `title` points to an initialized memory.
 *
 * If these conditions are not met, the behavior is undefined.
 */
int crossterm_terminal_title(const char *title);

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus
